= Test::Unit

== Ȥ

* ƥоݤΥ(foo.rb)

    class Foo
       def foo
         "foo"
       end
       def bar
         "foo"
       end
    end

* ƥ(footest.rb)

    require 'test/unit'
    require 'foo'

    class TC_Foo < Test::Unit::TestCase
      def setup
        @obj = Foo.new
      end

      # def teardown
      # end

      def test_foo
        assert_equal("foo", @obj.foo)
      end
      def test_bar
        assert_equal("bar", @obj.bar)
      end
    end

* 

  * ٤Ƥƥ

        $ ruby footest.rb

        Loaded suite footest
        Started
        F.
        Finished in 0.022223 seconds.

          1) Failure!!!
        test_bar(TC_Foo) [footest.rb:16]:
        <bar> expected but was
        <foo>

        2 tests, 2 assertions, 1 failures, 0 errors

  * test_bar ƥ

        $ ruby footest.rb test_bar

        Loaded suite footest
        Started
        F
        Finished in 0.019573 seconds.

          1) Failure!!!
        test_bar(TC_Foo) [footest.rb:16]:
        <bar> expected but was
        <foo>

        1 tests, 1 assertions, 1 failures, 0 errors

  * gtk Ȥä testrunner

        $ ruby footest.rb --gtk test_bar

  * fox Ȥ

        $ ruby footest.rb --fox test_bar

  * console Ȥ (default)

        $ ruby footest.rb --console test_bar

= Test::Unit::Assertions

== ᥽å

 assertion κǸΰ message ϥƥȤԤȤɽ
å

--- assert(boolean, message="")

    boolean ʤ pass

--- assert_equal(expected, actual, message=nil)
--- assert_not_equal(expected, actual, message="")

    expected == actual ʤ pass

    expected != actual ʤ pass

--- assert_raises(expected_exception_klass, message="") { ... }

    block ¹Ԥ expected_exception_klass 饹㳰
    ȯ pass

--- assert_instance_of(klass, object, message="")

    klass == object.class ʤ pass

--- assert_nil(object, message="")
--- assert_not_nil(object, message="")

    object.nil? ʤ pass

    !object.nil? ʤ pass

--- assert_kind_of(klass, object, message="")

    object.kind_of?(klass) ʤ pass

--- assert_respond_to(object, method, message="")

    object.respond_to?(method) ʤ pass

--- assert_match(pattern, string, message="")
--- assert_no_match(regexp, string, message="")

    string =~ pattern ʤ pass

    regexp !~ string ʤ pass

--- assert_same(expected, actual, message="")
--- assert_not_same(expected, actual, message="")

    actual.equal?(expected) ʤ pass

    !actual.equal?(expected) ʤ pass

--- assert_operator(object1, operator, object2, message="")

    object1.send(operator, object2) ʤ pass

--- assert_nothing_raised(*args) { ... }

    block 㳰ȯʤ pass

--- flunk(message="")

    ˼

--- assert_throws(expected_symbol, message="") { ... }
--- assert_nothing_thrown(message="") { ... }

    block  throw :expected_symbol  pass

    block  throw ʤ pass

--- assert_in_delta(expected_float, actual_float, delta, message="")

    (expected_float.to_f - actual_float.to_f).abs <= delta.to_f 
    ʤ pass

    delta οǤʤФʤʤ

--- assert_send(send_array, message="")

    send_array[0].__send__(send_array[1], *send_array[2..-1])
    ʤ pass

--- assert_block(message="") { ... }

    block η̤ʤ pass

== RubyUnit ΰܹ

assertion ᥽åɤΰ㤤 ((<"ruby-src:lib/runit/assert.rb">)) 򻲾ȡ
((<RUNIT::Assert>)) ⻲ȡ
