= fileutils.rb

((<ruby 1.7 feature>))

== module FileUtils

Ūʥե򽸤᤿⥸塼Ǥ

=== ⥸塼ؿ

--- FileUtils.cd( dir, *options )
--- FileUtils.cd( dir, *options ) {|dir| .... }
  Options: noop verbose

  ǥ쥯ȥ dir ˰ưޤ
  ƥ졼ȤƸƤФ줿ϥ֥åλ
  Υǥ쥯ȥޤ

    FileUtils.cd '/', :verbose   # chdir and report it

--- FileUtils.uptodate?( newer, older_list, *options )
  Options: verbose

  newer older_list ˴ޤޤ뤹٤ƤΥե꿷Ȥ
  ¸ߤʤե̵¤˸ŤȤߤʤޤ

    FileUtils.newest? 'hello.o', 'hello.c', 'hello.h' or system 'make'

--- FileUtils.mkdir( dir, *options )
  Options: noop verbose

  ǥ쥯ȥ dir ޤ

    FileUtils.mkdir 'test'
    FileUtils.mkdir %w( tmp data )
    FileUtils.mkdir 'notexist', :noop  # does not create really

--- FileUtils.mkdir_p( dir, *options )
  Options: noop verbose

  ǥ쥯ȥ dir Ȥοƥǥ쥯ȥƺޤ
  㤨

    FileUtils.mkdir_p '/usr/local/lib/ruby'

  ϰʲǥ쥯ȥ(ʤ)ޤ
      * /usr
      * /usr/local
      * /usr/local/bin
      * /usr/local/bin/ruby

--- FileUtils.rmdir( dir, *options )
  Options: noop, verbose

  removes directory DIR.

    FileUtils.rmdir 'somedir'
    FileUtils.rmdir %w(somedir anydir otherdir)
    # does not remove directory really, outputing message.
    FileUtils.rmdir 'somedir', :verbose, :noop

--- FileUtils.ln( old, new, *options )
  Options: force noop verbose

  old ؤΥϡɥ new ޤ
  new Ǥ¸ߤǥ쥯ȥǤȤ new/old ޤ
  new Ǥ¸ߤǥ쥯ȥǤʤʤ㳰 Errno::ENOTDIR ȯޤ
   force ץꤷȤ new 񤭤ޤ

    FileUtils.ln 'gcc', 'cc', :verbose
    FileUtils.ln '/usr/bin/emacs21', '/usr/bin/emacs'

--- FileUtils.ln( list, destdir, *options )
  Options: force noop verbose

  list[0] ؤΥϡɥ destdir/list[0]list[1] ؤ
  ϡɥ destdir/list[1] Ĥޤ
  destdir ǥ쥯ȥǤʤ㳰 Errno::ENOTDIR ȯޤ

    include FileUtils
    cd '/bin'
    ln %w(cp mv mkdir), '/usr/bin'

--- FileUtils.ln_s( old, new, *options )
  Options: force noop verbose

  old ؤΥܥå new ޤ
  new Ǥ¸ߤǥ쥯ȥǤȤ new/old ޤ
  new Ǥ¸ߤǥ쥯ȥǤʤʤ㳰 Errno::ENOTDIR ȯޤ
   force ץꤷȤ new 񤭤ޤ

    FileUtils.ln_s '/usr/bin/ruby', '/usr/local/bin/ruby'
    FileUtils.ln_s 'verylongsourcefilename.c', 'c', :force

--- FileUtils.ln_s( list, destdir, *options )
  Options: force noop verbose

  list[0]list[1] ĤؤΥܥå dir/list[0], dir/list[1] Ĥ
  ޤdestdir ǥ쥯ȥǤʤ㳰 Errno::ENOTDIR 
  ȯޤ
  list[0] ؤΥܥå destdir/list[0]list[1] ؤ
  ϡɥ destdir/list[1] Ĥޤ
  destdir ǥ쥯ȥǤʤ㳰 Errno::ENOTDIR ȯޤ

   FileUtils.ln_s Dir.glob('bin/*.rb'), '/home/aamine/bin'

--- FileUtils.ln_sf( src, dest, *options )
  Options: noop verbose

  ln_s(src,dest,:force) ƱǤ

--- FileUtils.cp( src, dest, *options )
  Options: preserve noop verbose

  ե src  dest ˥ԡޤdest ǥ쥯ȥʤ
  dest/src ˥ԡޤdest ¸ߤǥ쥯ȥ
  ʤȤϾ񤭤ޤ

    FileUtils.cp 'eval.c', 'eval.c.org'

--- FileUtils.cp( list, dir, *options )
  Options: preserve noop verbose

  file1  dir/file1 ˥ԡfile2  dir/file2 ˥ԡ
  Ȥ褦ˡǥ쥯ȥ dir ˥ե file1file2 Ĥ
  Ʊ̾ǥԡޤdir ǥ쥯ȥǤʤ㳰
  Errno::ENOTDIR ȯޤ

    FileUtils.cp 'cgi.rb', 'complex.rb', 'date.rb', '/usr/lib/ruby/1.6'
    FileUtils.cp :verbose, %w(cgi.rb complex.rb date.rb), '/usr/lib/ruby/1.6'

--- FileUtils.cp_r( src, dest, *options )
  Options: preserve noop verbose

  src  dest ˥ԡޤsrc ǥ쥯ȥǤäƵŪ
  ԡԤޤκ dest ǥ쥯ȥʤ dest/src 
  ԡޤ

    # installing ruby library "mylib" under the site_ruby
    FileUtils.rm_r site_ruby + '/mylib', :force
    FileUtils.cp_r 'lib/', site_ruby + '/mylib'

--- FileUtils.cp_r( list, dir, *options )
  Options: preserve noop verbose

  list[0]list[1], list[2], Ĥǥ쥯ȥ dir ˥ԡޤ
  list[n] ǥ쥯ȥʤƵŪ˥ԡޤ

    FileUtils.cp_r %w(mail.rb field.rb debug/) site_ruby + '/tmail'
    FileUtils.cp_r Dir.glob('*.rb'), '/home/aamine/lib/ruby', :noop, :verbose

--- FileUtils.mv( src, dest, *options )
  Options: noop verbose

  from  to ˰ưޤto ǥ쥯ȥʤ to/from 
  ưޤİʾΰͿȤϥǥ쥯ȥ dir 
  ˤ¾Υեưޤ

    FileUtils.mv 'badname.rb', 'goodname.rb'
    FileUtils.mv 'stuff.rb', 'lib/ruby', :force

--- FileUtils.mv( list, dir, *options )
  Options: noop verbose

  file1 file2 Ĥ dir/file1 dir/file2 Ĥ˰ưޤ
  ѡƥޤǰưȤϥԡޤ

    FileUtils.mv 'junk.txt', 'dust.txt', '/home/aamine/.trash/'
    FileUtils.mv Dir.glob('test*.rb'), 'T', :noop, :verbose

--- FileUtils.rm( list, *options )
  Options: force noop verbose

  list[0]list[1] Ĥõޤ:force ץ
  åȤ줿Ϻ椹٤Ƥ StandardError ̵뤷ޤ

    FileUtils.rm %w( junk.txt dust.txt )
    FileUtils.rm Dir['*.so']
    FileUtils.rm 'NotExistFile', :force    # never raises exception

--- FileUtils.rm_r( list, *options )
  Options: force noop verbose

  եޤϥǥ쥯ȥ list[0], list[1] Ĥõޤ
  force ץϤ StandardError ̵뤷ޤ

    FileUtils.rm_r Dir.glob('/tmp/*')
    FileUtils.rm_r '/', :force          #  :-)

--- FileUtils.rm_rf( list, *options )
  Options: noop verbose

  same to rm_r(list,:force)

--- FileUtils.cmp( file_a, file_b, *options )
  Options: verbose

  ե a  b ƤƱʤ鿿

    FileUtils.cmp 'somefile', 'somefile'  #=> true
    FileUtils.cmp '/bin/cp', '/bin/mv'    #=> maybe false.

--- FileUtils.install( src, dest, mode = <src's>, *options )
  Options: noop verbose

  from  to Ƥ㤦Ȥ from  to ˥ԡޤ
  Τ⡼ɤ mode ꤷޤ

    FileUtils.install 'ruby', '/usr/local/bin/ruby', 0755, :verbose
    FileUtils.install 'lib.rb', '/usr/local/lib/ruby/site_ruby', :verbose

--- FileUtils.chmod( mode, list, *options )
  Options: noop verbose

  ե LIST[0]LIST[1] ĤΥѡߥå mode Ѥޤ

    FileUtils.chmod 0644, 'my.rb', 'your.rb'
    FileUtils.chmod 0755, 'somecommand'
    FileUtils.chmod 0755, '/usr/bin/ruby', :verbose

--- FileUtils.touch( list, *options )
  Options: noop verbose

  list[0], list[1] Ĥκǽѹ (mtime) ȥ (atime) 
  ޤlist[n] ¸ߤʤ϶Υեޤ

    FileUtils.touch 'timestamp'
    FileUtils.touch Dir.glob('*.c');  system 'make'

== module FileUtils::Verbose

FileUtils Ʊ᥽åɤƤƱ
ư򤷤ޤ¹ˤ褦ȤƤ뤳Ȥɽޤ

== module FileUtils::NoWrite

FileUtils Ʊ᥽åɤƤޤ
ºݤ˥եѹϼ¹Ԥޤ
