= net/http.rb

== Υ饤֥ˤĤ

ѥǡžץȥ HTTP 򰷤饤֥Ǥ
 [RFC2616] ((<URL:http://www.ietf.org/rfc/rfc2616.txt>)) 
𤤤Ƥޤ

== 

=== ֥ФɥȤ (GET)

    require 'net/http'
    Net::HTTP.start( 'some.www.server', 80 ) {|http|
      response , = http.get('/index.html')
      puts response.body
    }

ޤʲƱ̣û񤤤ΤǤ

    require 'net/http'
    Net::HTTP.get_print 'some.www.server', '/index.html'

=== եξ (POST)

    require 'net/http'
    Net::HTTP.start( 'some.www.server', 80 ) {|http|
        response , = http.post( '/cgi-bin/any.rhtml',
                                'querytype=subject&target=ruby' )
    }

(: ((<եͤζڤʸˤĤ|URL:#%A5%D5%A5%A9%A1%BC%A5%E0%A4%CE%C3%CD%A4%CE%B6%E8%C0%DA%A4%EA%CA%B8%BB%FA%A4%CB%A4%C4%A4%A4%A4%C6>)))


=== ץͳΥ

Net::HTTP Υ饹᥽å Net::HTTP.Proxy ϡ˥ץͳ
³褦ư򤹤롢饹֤ޤΥ饹
Net::HTTP ѾƤΤ Net::HTTP Ʊ褦˻Ȥޤ

    require 'net/http'

    $proxy_addr = 'your.proxy.addr'
    $proxy_port = 8080
          :
    Net::HTTP::Proxy($proxy_addr, $proxy_port).start( 'some.www.server' ) {|http|
      # always connect to your.proxy.addr:8080
          :
    }

ޤ Net::HTTP.Proxy  nil  Net::HTTP Ȥ֤Τ
ΥɤΤ褦˽񤤤ƤХץʤξˤбǤޤ

=== 쥯Ȥб

    require 'uri'
    require 'net/http'
    Net::HTTP.version_1_1
 
    uri = URI.parse 'http://www.ruby-lang.org/'
    begin
      Net::HTTP.start( uri.host, uri.port ) {|http|
        response , = http.get(uri.request_uri)
        print response.body
      }
    rescue Net::ProtoRetriableError => err
      uri = URI.parse err.response['location']
      retry
    end

ºݤˤϥ쥯Ȥ̵¥롼פн褹ʤɤνɬפȤʤޤ

Ruby 1.6.7 ̤δĶǤ URI 饹ɸźդƤʤΤǡĴ
ã뤫뤤ϤʤʲΤ褦ˤɤǤ礦

    require 'net/http'
    Net::HTTP.version_1_1

    host = 'www.ruby-lang.org'
    path = '/'
    begin
      Net::HTTP.start( host, 80 ) {|http|
        response , = http.get(path)
        print response.body
      }
    rescue Net::ProtoRetriableError => err
      if m = %r<http://([^/]+)>.match( err.response['location'] ) then
        host = m[1].strip
        path = m.post_match
        retry
      end
    end

=== Basic ǧ

    require 'net/http'

    Net::HTTP.start( 'auth.some.domain' ) {|http|
        response , = http.get( '/need-auth.cgi',
                'Authorization' => 'Basic ' + ["#{account}:#{password}"].pack('m').strip )
        print response.body
    }

С 1.2 (Ruby 1.7 ʹߤź) ǤϼΤ褦˽񤱤ޤ

    require 'net/http'

    req = Net::HTTP::Get.new('/need-auth.cgi')
    req.basic_auth 'account', 'password'
    Net::HTTP.start( 'auth.some.domain' ) {|http|
        response = http.request(req)
        print response.body
    }

== ͤؤѹȰܹ֤ˤĤ

Ruby 1.6 äƤΤ http.rb 1.1  1.7 ʹߤ 1.2 Ǥ
δ֤ǤϤʤ礭ͤѤޤ˻ͤѹ
ΤǤʤξμ¸ߤ뤳Ȥˤޤ

᥽å HTTP.version_1_2HTTP.version_1_1 Ƥ֤
ΤȤ Net::HTTP ֥ȤϤ줾
Сλͤư褦ˤʤޤʲϻǤ

    # example
    Net::HTTP.start {|http1| ...(http1 has 1.2 features)... }

    Net::HTTP.version_1_1
    Net::HTTP.start {|http2| ...(http2 has 1.1 features)... }

    Net::HTTP.version_1_2
    Net::HTTP.start {|http3| ...(http3 has 1.2 features)... }

εǽϥåɥդǤϤޤ

== class Net::HTTP

=== 饹᥽å

: new( address, port = 80, proxy_addr = nil, proxy_port = nil )
     HTTP ֥Ȥޤaddress  HTTP С FQDN ǡ
    port ³ݡֹǤΥ᥽åɤǤϤޤ³Ϥޤ

    proxy_addr Ϳȥץ𤷤³륪֥Ȥޤ

: start( address, port = 80, proxy_addr = nil, proxy_port = nil )
: start( address, port = 80, proxy_addr = nil, proxy_port = nil ) {|http| .... }
    ʲƱǤ

        Net::HTTP.new(address, port, proxy_addr, proxy_port).start(&block)

: get( address, path, port = 80 )
    ۥ address  port ֥ݡȤ³ path ɽ
    ƥƥʸ֤ޤ

: get_print( address, path, port = 80 )
    ۥ address  port ֥ݡȤ³ path ɽ
    ƥƥ$stdout  << ǽϤޤ

: Proxy( address, port = 80 )
    ˻ꤵ줿ץ³륯饹֤ޤ
    Υ饹 Net::HTTP ѾƤΤ Net::HTTP 
    Ʊ褦˻Ȥޤ

    address  nil ΤȤ Net::HTTP 饹򤽤Τޤ֤ޤ

        # example
        proxy_class = Net::HTTP::Proxy( 'proxy.foo.org', 8080 )
                        :
        proxy_class.start( 'www.ruby-lang.org' ) {|http|
            # connecting proxy.foo.org:8080
                        :
        }

: proxy_class?
    Ȥ (Proxy ᥽åɤˤäƺ줿) ץѤΥ饹ʤп

: port
    HTTP Υǥեȥݡ (80)

=== ᥽å

: start
: start {|http| .... }
    TCP ͥĥꡢHTTP å򳫻Ϥޤ
    Ǥ˥å󤬳ϤƤ㳰 IOError ȯޤ

    ƥ졼ȤƸƤФ줿ϥ֥åδ֤å³
    ֥åλȤȤ˼ưŪ˥åĤޤ

: active?
    HTTP å󤬳ϤƤ鿿

: address
    ³륢ɥ쥹

: port
    ³ݡֹ

: open_timeout
: open_timeout=(n)
    ³ԤĺÿÿäƤ⥳ͥ
    ʤ㳰 TimeoutError ȯޤ

: read_timeout
: read_timeout=(n)
    ɤߤ (read(1) ) ǥ֥åƤ褤ÿ
    ÿäƤɤߤʤ㳰 TimeoutError ȯޤ

: finish
    HTTP åλޤå󳫻ˤΥ᥽åɤ
    ƤФ줿㳰 IOError ȯޤ

: proxy?
    ץ𤷤³ʤ鿿

: proxy_address
    ץͳ³ HTTP ֥ȤʤץΥɥ쥹
    Ǥʤʤ nil

: proxy_port
    ץͳ³ HTTP ֥ȤʤץΥݡȡ
    Ǥʤʤ nil

: get( path, header = nil )
: get( path, header = nil ) {|str| .... }
    о path ˤ륨ƥƥޤޤ header  nil
    ǤʤСꥯȤȤˤƤ HTTP إåȤƽ
    ߤޤheader ϥϥåǡ֥إå̾ => ơפΤ褦ʷ
    ʤФޤ

    ͤϡС 1.1 Ǥ HTTPResponse ȥƥƥܥǥʸ
    ǤǤ1.2 Ǥ HTTPResponse ҤȤĤΤߤǤξ硢
    ƥƥܥǥ response.body ޤ

    ֥åȤȤ˸ƤФ줿ϥƥƥܥǥ򾯤Ťĥ֥å
    Ϳޤ

    1.1 Ǥ 3xx (ƻԲǽʥ顼)ФƤ㳰ȯޤξ
    HTTPResponse 㳰֥Ȥ err.response 뤳ȤǤޤ
     1.2 Ǥ㳰ȯޤ

        # version 1.1 (bundled with Ruby 1.6)
        response, body = http.get( '/index.html' )

        # version 1.2 (bundled with Ruby 1.7 or later)
        response = http.get( '/index.html' )

        # compatible in both version
        response , = http.get( '/index.html' )
        response.body
        
        # using block
        File.open( 'save.txt', 'w' ) {|f|
            http.get( '/~foo/', nil ) do |str|
              f.write str
            end
        }

: head( path, header = nil )
    о path ˤ륨ƥƥΥإåΤߤޤ
    ޤ header  nil ǤʤХꥯȤȤˤƤ
    HTTP إåȤƽ񤭤ߤޤheader ϥϥåǡ
    ֥إå̾ => ơפΤ褦ʷǤʤФޤ

    HTTPResponse ֥Ȥ֤ޤ

    1.1 Ǥ 3xx (ƻԲǽʥ顼)ФƤ㳰ȯޤξ
    HTTPResponse 㳰֥Ȥ err.response 뤳ȤǤޤ
     1.2 Ǥ㳰ȯޤ

        response = nil
        Net::HTTP.start( 'some.www.server', 80 ) {|http|
            response = http.head( '/index.html' )
        }
        p response['content-type']

: post( path, data, header = nil )
: post( path, data, header = nil ) {|str| .... }
    о path ˤ륨ƥƥФʸ data 
    ޤ쥹ݥ󥹤 << ᥽åɤȤä dest ˽
    ޤޤheader  get ᥽åɤƱǤ
    HTTPResponse ֥Ȥ dest ֤ޤ

    ƥ졼ȤƸƤӤ줿Ȥϥƥƥܥǥ򾯤Ť
    ֥åͿޤ

    1.1 Ǥ 3xx (ƻԲǽʥ顼)ФƤ㳰ȯޤξ
    HTTPResponse 㳰֥Ȥ err.response 뤳ȤǤޤ
     1.2 Ǥ㳰ȯޤ

        # version 1.1
        response, body = http.post( '/cgi-bin/search.rb', 'query=subject&target=ruby' )

        # version 1.2
        response = http.post( '/cgi-bin/search.rb', 'query=subject&target=ruby' )

        # compatible in both version
        response , = http.post( '/cgi-bin/search.rb', 'query=subject&target=ruby' )

        # using block
        File.open( 'save.html', 'w' ) {|f|
            http.post( '/cgi-bin/search.rb',
                       'query=subject&target=ruby' ) do |str|
              f.write str
            end
        }

: request_get( path, header = nil )
: request_get( path, header = nil ) {|response| .... }
    path ˤ륨ƥƥޤHTTPResponse
    ֥Ȥ֤ޤ

    ֥åȤȤ˸ƤӽФ줿Ȥϡ֥å¹³
    ݻޤ HTTPResponse ֥Ȥ֥åϤޤ

    Υ᥽åɤ HTTP ץȥ˴Ϣ㳰ȯޤ

        # example
        response = http.request_get( '/index.html' )
        p response['content-type']
        puts response.body          # body is already read

        # using block
        http.request_get( '/index.html' ) {|response|
            p response['content-type']
            response.read_body do |str|   # read body now
              print str
            end
        }

: request_post( path, data, header = nil )
: request_post( path, data, header = nil ) {|response| .... }
    path ˤ륨ƥƥޤHTTPResponse
    ֥Ȥ֤ޤ

    ֥åȤȤ˸ƤӽФ줿Ȥϡܥǥɤߤ
    HTTPResponse ֥Ȥ֥åϤޤ

    Υ᥽åɤ HTTP ץȥ˴Ϣ㳰ȯޤ

        # example
        response = http.post2( '/cgi-bin/nice.rb', 'datadatadata...' )
        p response.status
        puts response.body          # body is already read

        # using block
        http.post2( '/cgi-bin/nice.rb', 'datadatadata...' ) {|response|
          p response.status
          p response['content-type']
          response.read_body do |str|   # read body now
            print str
          end
        }

: request( request [, data] )
: request( request [, data] ) {|response| .... }
    HTTPResquest ֥ request ޤPOST/PUT λ data 
    Ϳޤ (POST/PUT ʳ data Ϳ ArgumentError ȯޤ)

    ֥åȤȤ˸ƤӤ줿Ȥϥܥǥɤߤޤ HTTPResponse
    ֥Ȥ֥åͿޤ

    Υ᥽åɤ HTTP ץȥ˴Ϣ㳰ȯޤ

== class Net::HTTPRequest

HTTP ꥯȤݲ륯饹Net::HTTPRequest ݥ饹
ʤΤǼºݤˤϲ̥饹 Net::HTTP::Get, Post, Head, Put 
Ƥ

=== 饹᥽å

: new
    HTTP ꥯȥ֥Ȥޤ

=== ᥽å

: self[ key ]
    key إåեɤʸ
    key ʸʸ̤ޤ

: self[ key ] = val
    key إåեɤ val 򥻥åȤޤ
    key ʸʸ̤ޤ

: each {|name, val| .... }
    إå̾ȤͤФ뤯꤫إå̾Ͼʸ줵ޤ

: basic_auth( account, password )
    Authrization: إå basic auth Ѥ˥åȤޤ

: range
    Range: إåμϰϤ Range ֥Ȥ֤ޤ

: range = r
: set_range( i, len )
    ϰϤꤷƥƥƥ뤿Υإå Range: 򥻥åȤޤ
    r  Range ֥ȡi, len ϻĹǤ

: content_length
    Content-Length: إå ()

: content_range
    Content-Range: إå (Range)

== class Net::HTTPResponse

HTTP 쥹ݥ󥹤Υ饹Ǥ
إåե̾Ǥ硢ʸʸ̤ޤ

=== ᥽å
 
: self[ key ]
    key إåե(ʸ)֤ޤ
    ȤХ 'content-length' ФƤ '2048' Τ褦
    ʸޤkey ʸʸ̤ޤ

: self[ key ] = val
    key إåեɤ value ꤷޤ
    key ʸʸ̤ޤ

: key?( key )
    key Ȥإåեɤп
    key ʸʸ̤ޤ

: each {|name,value| .... }
    ٤ƤΥإåե̾ȤͤΥڥФ뤯꤫

: canonical_each {|name,value| .... }
    إåեɤ̾ȤͤΥڥФƷ֤ޤ

: code
    HTTP ΥꥶȥɤǤ㤨 '302' ʤɤǤ

: message
    HTTP Фꥶȥɤղä֤åǤ
    㤨 'Not Found' ʤɤǤ

: read_body( dest = '' )
    ƥƥܥǥ dest  << ᥽åɤȤäƽ񤭤ߤޤ
    Ʊ HTTPResponse ֥ȤФʾƤФ줿硢
    ܤϤʤˤ⤻˰ܤͤ򤽤Τޤ֤ޤ

: read_body {|str| .... }
    ƥƥܥǥ򾯤Ťļƽ缡֥åͿޤ

: body
    ƥƥܥǥǤread_body ƤǤФΰ dest
    ƤǤʤХƥƥܥǥʸȤɤߤ֤ޤ

== 㳰

getheadpost ᥽åɤȯ HTTP ץȥϢ㳰Ȥơ
ʲ˵󤲤Τޤ
˵󤲤㳰饹οƥ饹Ϥ٤ Net::ProtocolError 饹ǡ
response ᥽åɤˤäƥ顼θȤʤä쥹ݥ󥹥֥Ȥ
뤳ȤǤޤ

  * ProtoRetriableError

    HTTP ơ 3xx äȯޤ
    ꥽ưʤɤͳˤꡢꥯȤλˤϹ
    륢ɬפˤʤޤ

  * ProtoFatalError

    HTTP ơ 4xx äȯޤ
    饤ȤΥꥯȤ˸꤬뤫Ф˥ꥯȤݤ
    줿(ǧڤɬס꥽¸ߤʤʤɤ)Ȥ򼨤ޤ

  * ProtoServerError

    HTTP ơ 5xx äȯޤ
    ФꥯȤ˥顼ȯȤ򼨤ޤ

  * ProtoUnknownError

    ץȥΥС󤬾夬ä뤤ϥ饤֥ΥХʤɤǡ
    饤֥꤬бƤʤȯޤ

== եͤζڤʸˤĤ

POST application/x-www-form-urlencoded ȤʣΥեͤ硢
߹ԤʤƤΤϡ name0=value0&name1=value1 Τ褦˥ѥ 
`&' Ƕڤ꤫Ǥ
ˡϡRFC1866 Hypertext Markup Language - 2.0 ǽƸо줷
HTML 4.01 Specification  
((<17.13.4 Form content types|URL:http://www.w3.org/TR/html401/interact/forms.html#h-17.13.4.1>)) 
Ǥ⤽Τ褦˽񤫤Ƥޤ

ȤƱ HTML 4.01 Specification 
((<B.2.2 Ampersands in URI attribute values|URL:http://www.w3.org/TR/html401/appendix/notes.html#h-B.2.2>))
Ǥϡ `&' SGMLʸλȤѤ뤳ȤŦƤꡢ
CGI䥵ФμԤФ `&' 
ߥ `;' 򥵥ݡȤ뤳Ȥ򾩤Ƥޤ

ºݤˤ `;' ᤷʤCGI䥵Фޤޤ뤿
Υե󥹥ޥ˥奢ǤȤ `&' Ѥޤ

ʤRuby  ((<CGI>)) 饤֥ǤϤɤ⥵ݡȤƤޤΤǡ
((<cgi.rb>)) ѤCGIץȤ񤯾Ϥΰ㤤
ˤɬפϤʤǤ礦

